<html>

<head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta http-equiv="Content-Language" content="en">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>
        Streaming</title>
    <meta name="viewport"
        content="width=device-width, initial-scale=1, maximum-scale=1, user-scalable=no, shrink-to-fit=no" />
    <meta name="description" content="This is an example dashboard created using build-in elements and components.">
    <meta name="msapplication-tap-highlight" content="no">
    <link href="{{ url_for('static', filename='css/index_main.css') }}" rel="stylesheet">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.3.1/jquery.slim.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/aws-sdk/2.490.0/aws-sdk.min.js"></script>

    <style>
        /* Alert section styling */
        .alert {
            padding: 15px;
            color: white;
            opacity: 1;
            transition: opacity 0.6s;
            margin-bottom: 15px;
            display: none;
        }

        .alert.high {
            background-color: #f44336;
        }

        .alert.medium {
            background-color: #ff9800;
        }

        .alert.low {
            background-color: #04AA6D;
        }

        /* Styling for the different section on the page */
        ul {
            list-style: none;
            padding: 0;
        }
        li {
            list-style: none;
            padding: 0;
        }
  
        .sortable-list {
            list-style-type: none;
            padding: 0;
            width: 50%;
            box-sizing: border-box; 
        }    
        #sortable-list-2 {

            width: 50%;
        }

        .content {
            width: 50%;
            box-sizing: border-box; 
        }

        .content-item {
            margin: 10px;
            padding: 10px;
            border: 1px solid #ddd;
        }
        .closebtn {
            margin-left: 15px;
            color: white;
            font-weight: bold;
            float: right;
            font-size: 22px;
            line-height: 20px;
            cursor: pointer;
            transition: 0.3s;
        }

        .closebtn:hover {
            color: black;
        }
        #playerContainer,
        .player {
            width: 100%;
            height: auto;
            min-height: 400px;
            outline: none;
        }

        .vjs-big-play-button {
            display: none !important;
        }
         #modelInfoTable {
            width: 100%;
            border-collapse: collapse;
        }
        #modelInfoTable th {
            background-color: #f2f2f2;
            text-align: left;
            padding: 8px;
        }
        #modelInfoTable td {
            border-bottom: 1px solid #ddd;
            padding: 8px;
        }

        #modelInfoTable tbody tr:nth-child(even) {
            background-color: #f2f2f2;
        }

        #modelInfoTable th {
            font-weight: bold;
        }
        .btn {
            display: inline-block;
            float: right;
            font-weight: 400;
            color: #495057;
            text-align: center;
            user-select: none;
            background-color: whitesmoke;
            border: 3px solid black;
            padding: .375rem .75rem;
            font-size: 1rem;
            line-height: 1.5;
            border-radius: .25rem;
            transition: color 0.15s, background-color 0.15s, border-color 0.15s, box-shadow 0.15s;

       }
       #toggleButton {
            width: auto; 
            font-size: 20px;
            padding: 10px 20px;
            margin-right: 5%;
            border: 3px solid rgb(92, 91, 91);
            border-radius: 10px;
            white-space: nowrap;
            background-color: #bfbcbc;
            font-weight: bold;
       }
   /* Header styling */
   .app-header {
            display: flex;
            justify-content: space-between;
            align-items: center;
        }
        .app-header .left-items {
            display: flex;
            align-items: center;
            flex-grow: 0;
        }
        .app-header .right-items {
            display: flex;
            align-items: center;
            flex-grow: 0;
        }

        body {
            overflow-x: hidden;
        }
        .mb-3, .card {
            margin-bottom: 0px !important;
        }
        .mb-4, .card {
            margin-bottom: 0px !important;
        }
        .card-header-title{
            padding: 10px;
        }
        #dynamicTable {
            width: 100%;
            border-collapse: collapse;
        }
        #dynamicTable th {
            background-color: #f2f2f2;
            text-align: left;
            padding: .55rem;
            font-weight: bold;
        }
        #dynamicTable td {
            border-bottom: 1px solid #ddd;
            padding: .55rem;
        }
        #dynamicTable tbody tr:nth-child(even) {
            background-color: #f2f2f2;
        }
        .tbody {
            font-size:20px;
            text-align:center !important;
            vertical-align: middle;
            padding: .55rem;
            color:#495057;
        }
        tbody tr td:nth-child(2) {
          font-weight: bold;
          color: #6c757d !important;
          text-transform: capitalize;
        }
        .thead {
            font-size:20px;
            text-align:center;
            vertical-align: middle;
            padding: .55rem;
            color:#495057;
            font-weight: bold;
        }
        .text-set {
            text-align: center !important;
        }
    </style>
</head>

<body>
    <div class="app-container app-theme-white body-tabs-shadow fixed-header">
        <div class="app-header">
            <div class="left-items" style="margin-left: 1%;">
                <img width="200px" height="50px" src="{{ url_for('static', filename='images/avatars/arm.png') }}"></img>
            <div class="left-items" style="font-size:25px">&emsp; Monitoring System</div>
            </div>
            <div class="right-items" style="margin-left: 1%;">
                <button class="btn" onclick="toggleButton()" id="toggleButton" style="font-size:20px;">Enable Dynamic Feature</button>
            </div>
        </div>
        <div class="app-main">
            <div class="app-main__outer">
                <div class="app-main__inner">
                    <div id ="dynamic-content">
                    <div class="row">
                        <ul class="sortable-list" id="sortable-list">
                            <li class="content-item" data-id="text">
                            <div class="mb-3 card">
                                <div class="card-header-tab card-header-tab-animation card-header">
                                    <div class="card-header-title" style="font-size:18px; height:70px">
                                        <i class="header-icon lnr-apartment icon-gradient bg-love-kiss"> </i>
                                        Live Camera Streaming <br>through KVS<p id="count"></p>
                                    </div>
                                    <ul class="nav" style="font-size:20px">
                                        <li class="nav-item"><a href={{ link_1 }} target="_blank"
                                                                                        class="active nav-link">{{ device_1 }}</a></li>
                                        <!-- <li class="nav-item"><a href={{ link_2 }} target="_blank"
                                                                                        class="nav-link second-tab-toggle">{{ device_2 }}</a></li> -->
                                    </ul>
                                </div>
                                <div class="card-body" id="playerContainer">
                                        <video id="hlsjs" class="player" controls muted autoplay></video>
                                        <img src="{{ url_for('video_feed') }}" width="100%" hidden>
                                        <script src="https://cdn.jsdelivr.net/npm/hls.js@latest"></script>
                                        <script>
                                           
                                            var video = document.getElementById('hlsjs');
    
                                            function checkVideoLoaded() {
    
    
                                                if (video.readyState === 4) {
                                                    clearInterval(refreshInterval);
                                                } else {
                                                    myFunction()
                                                }
                                            }
                                            var refreshInterval = setInterval(checkVideoLoaded, 20000);
    
                                            function myFunction() {
                                                var protocol = "HLS";
                                                var streamName = "{{ streamName }}";
                                                var accessKey = "{{accesskey}}";
                                                var secretKey = "{{secretKey}}";
                                                var region = "{{region}}"
                                                console.log(streamName);
                                                // Step 1: Configure SDK Clients
                                                var options = {
                                                    accessKeyId: accessKey,
                                                    secretAccessKey: secretKey,
                                                    sessionToken: $('#sessionToken').val() || undefined,
                                                    region: region,
                                                    endpoint: $('#endpoint').val() || undefined
                                                }
                                                var kinesisVideo = new AWS.KinesisVideo(options);
                                                var kinesisVideoArchivedContent = new AWS.KinesisVideoArchivedMedia(options);
    
                                                // Step 2: Get a data endpoint for the stream
                                                console.log('Fetching data endpoint');
                                                kinesisVideo.getDataEndpoint({
                                                    StreamName: streamName,
                                                    APIName: "GET_HLS_STREAMING_SESSION_URL"
                                                }, function (err, response) {
                                                    if (err) { return console.error(err); }
                                                    console.log('Data endpoint: ' + response.DataEndpoint);
                                                    kinesisVideoArchivedContent.endpoint = new AWS.Endpoint(response.DataEndpoint);
    
                                                    // Step 3: Get a Streaming Session URL
                                                    var consoleInfo = 'Fetching ' + protocol + ' Streaming Session URL';
                                                    console.log(consoleInfo);
                                                    kinesisVideoArchivedContent.getHLSStreamingSessionURL({
                                                        StreamName: streamName,
                                                        PlaybackMode: "LIVE",
                                                        HLSFragmentSelector: {
                                                            FragmentSelectorType: "SERVER_TIMESTAMP"
                                                        },
                                                        ContainerFormat: "FRAGMENTED_MP4",
                                                        DiscontinuityMode: "NEVER",
                                                        DisplayFragmentTimestamp: "NEVER",
                                                        MaxMediaPlaylistFragmentResults: parseInt($('#maxResults').val()),
                                                        Expires: parseInt(43200)
                                                    }, function (err, response) {
                                                        if (err) { return console.error(err); }
                                                        console.log('HLS Streaming Session URL: ' + response.HLSStreamingSessionURL);
    
                                                        // Step 4: Give the URL to the video player.
                                                        var playerName = "HLS.js";
                                                        if (playerName == 'HLS.js') {
                                                            var playerElement = $('#hlsjs');
                                                            playerElement.show();
                                                            var player = new Hls();
                                                            console.log('Created HLS.js Player');
                                                            player.loadSource(response.HLSStreamingSessionURL);
                                                            player.attachMedia(playerElement[0]);
                                                            console.log('Set player source');
                                                            player.on(Hls.Events.MANIFEST_PARSED, function () {
                                                                video.play();
                                                                console.log('Starting playback');
                                                            });
                                                        }
                                                    });
    
                                                });
                                            };
                                        </script>
                                    </div>
                                </div>
                            </li>
                            <li class="content-item" data-id="text">
                                <div class="mb-4 card">
                                    <div class="card-body1">
                                        <div class="card-header" style="font-size:20px">MODEL INFORMATION</div>
                                        <div class="table-responsive">
                                            <table id="modelInfoTable">
                                                <thead>
                                                    <tr>
                                                        <th style="text-align: center; font-size:17px">Attribute</th>
                                                        <th style="text-align: center; font-size:17px">Value</th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    <tr>
                                                        <td style="text-align: center; font-size:17px">Model Name</td>
                                                        <td style="text-align: center; font-size:17px">{{ model_data['model_name'] }}</td>
                                                    </tr>
                                                    <tr>
                                                        <td style="text-align: center; font-size:17px">Model Type</td>
                                                        <td style="text-align: center; font-size:17px">{{ model_data['model_dtype'] }}</td>
                                                    </tr>
                                                    <tr>
                                                        <td style="text-align: center; font-size:17px">Image Size</td>
                                                        <td style="text-align: center; font-size:17px">{{ model_data['image_size'] }}</td>
                                                    </tr>
                                                </tbody>
                                            </table>
                                            </div> 
                                    </div>
                                </div>
                            </li>

                            <li class="content-item" data-id="text">
                                <div class= "mb-3 card">
                                    <div class="card-body1">
                                        <div class="card-header" style="font-size:20px">PLATFORM INFORMATION</div>
                                        <div class="table-responsive">
                                            <table id="modelInfoTable">
                                                <thead>
                                                    <tr>
                                                        <th style="text-align: center; font-size:17px">Attribute</th>
                                                        <th style="text-align: center; font-size:17px">Value</th>
                                                    </tr>
                                                </thead>
                                                <tbody>
                                                    <tr>
                                                        <td style="text-align: center; font-size:17px">Accelerator</td>
                                                        <td style="text-align: center; font-size:17px">{{ acc }}</td>
                                                    </tr>
                                                    <tr>
                                                        <td style="text-align: center; font-size:17px">Device</td>
                                                        <td style="text-align: center; font-size:17px">IMX93</td>
                                                    </tr>
                                                </tbody>
                                            </table>
                                            </div>       
                                    </div>
                                </div>
                            </li>
                        </ul>

                        <ul class="content" id="sortable-list-2">
                            <li class="content-item" data-id="text">
                                <div class="main-card mb-3 card">
                                    <div class="card-header" style="font-size:22px">{{message}}</div>
                                        <div class="table-responsive">
                                            {% if message == "CLASSIFICATION STATISTICS"%}
                                            <table id = "dynamicTable">
                                                <thead class = "thead">
                                                    <tr>
                                                        <th class="text-set" style="font-size:20px"> ID</th>
                                                        <th class="text-set" id="left-align" style="font-size:20px"> Class Name</th>
                                                        <th class="text-set" style="font-size:20px"> Class Scores</th>
                                                    </tr>
                                                </thead>
                                                <tbody class ="tbody">
                                                </tbody>
                                            </table>
                                                    
                                            {% else %}
                                            <table id = "dynamicTable">
                                                <thead class = "thead">
                                                    <tr>
                                                        <th class="text-set" style="font-size:20px"> ID</th>
                                                        <th class="text-set" id ="left-align"style="font-size:20px"> Class Name</th>
                                                        <th class="text-set" style="font-size:20px"> Class Detections</th>
                                                    </tr>
                                                </thead>
                                                <tbody class ="tbody">
                                                </tbody>
                                            </table>
                                            {% endif %}
                                </div>
                                </div>
                                </li>

                                <li class="content-item" data-id="text">
                                <div class="main-card mb-3 card">
                                    <div class="card-header" style="font-size:22px">FPS Stats
                                    </div>
                                    <div class="table-responsive">
                                        <table
                                            class="align-middle mb-0 table table-borderless table-striped table-hover">
                                            <thead>
                                                <tr>
                                                    <th class="text-center" style="font-size:20px">Number</th>
                                                    <th style="font-size:20px">Type</th>
                                                    <th class="text-center" style="font-size:20px">FPS</th>
                                                </tr>
                                            </thead>
                                            <tbody>
                                                <tr>
                                                    <td class="text-center text-muted" style="font-size:20px">#1
                                                    </td>
                                                    <td>
                                                        <div class="widget-content p-0">
                                                            <div class="widget-content-wrapper">
                                                                <div class="widget-content-left mr-3">
                                                                    <div class="widget-content-left">
                                                                        <img width="40" class="rounded-circle"
                                                                            src="{{ url_for('static', filename='images/avatars/10.png') }}"
                                                                            alt="">
                                                                    </div>
                                                                </div>
                                                                <div class="widget-content-left flex2">
                                                                    <div class="widget-heading" style="font-size:20px">
                                                                        End to End Inference
                                                                    </div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </td>
                                                    <td class="text-center" id="rest_fps" style="font-size:25px">
                                                    </td>

                                                </tr>
                                                <tr>
                                                    <td class="text-center text-muted" style="font-size:20px">#2
                                                    </td>
                                                    <td>
                                                        <div class="widget-content p-0">
                                                            <div class="widget-content-wrapper">
                                                                <div class="widget-content-left mr-3">
                                                                    <div class="widget-content-left">
                                                                        <img width="40" class="rounded-circle"
                                                                            src="{{ url_for('static', filename='images/avatars/10.png') }}"
                                                                            alt="">
                                                                    </div>
                                                                </div>
                                                                <div class="widget-content-left flex2">
                                                                    <div class="widget-heading" style="font-size:20px">
                                                                        WEB UI FPS</div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </td>
                                                    <td class="text-center" id="web_fps" style="font-size:25px">
                                                    </td>
                                                </tr>
                                                <tr>
                                                    <td class="text-center text-muted" style="font-size:20px">#3
                                                    </td>
                                                    <td>
                                                        <div class="widget-content p-0">
                                                            <div class="widget-content-wrapper">
                                                                <div class="widget-content-left mr-3">
                                                                    <div class="widget-content-left">
                                                                        <img width="40" class="rounded-circle"
                                                                            src="{{ url_for('static', filename='images/avatars/10.png') }}"
                                                                            alt="">
                                                                    </div>
                                                                </div>
                                                                <div class="widget-content-left flex2">
                                                                    <div class="widget-heading" style="font-size:20px">
                                                                        Inference</div>
                                                                </div>
                                                            </div>
                                                        </div>
                                                    </td>
                                                    <td class="text-center" id="pure_fps" style="font-size:25px">
                                                    </td>
                                                </tr>
                                                

                                            </tbody>
                                        </table>
                                    </div>
                                </div>
                                </li>

                                <li class="content-item" data-id="text">
                                <div class="main-card mb-3 card">
                                    <div class="card-header" style="font-size:22px">Alert
                                    </div>
                                    <div class="alert high col-md-12" id="high" style="font-size:25px">
                                        <span class="closebtn">&times;</span>
                                        <strong>Alert !</strong> High traffic Area
                                    </div>
                                    <div class="alert medium col-md-12" id="medium" style="font-size:25px">
                                        <span class="closebtn">&times;</span>
                                        <strong>Alert!</strong> Medium traffic Area
                                    </div>
                                    <div class="alert low col-md-12" id="low" style="font-size:25px">
                                        <span class="closebtn">&times;</span>
                                        <strong>Alert!</strong> Low traffic Area
                                    </div>
                                </div>
                                </li>
                            </ul>
                        </div> 
                    </div>
                    </div>
                    </div>

                            <script src="http://maps.google.com/maps/api/js?sensor=true"></script>
                        </div>
                    </div>
                        <script type="text/javascript" src="{{ url_for('static', filename='scripts/index_main.js') }}"></script>
                        <script src="https://cdnjs.cloudflare.com/ajax/libs/socket.io/4.1.3/socket.io.min.js"></script>
                        <script src="https://cdnjs.cloudflare.com/ajax/libs/Sortable/1.14.0/Sortable.min.js"></script>
                        
                        <script>
                            const msg = "{{message}}";
                            var target_output_rest = document.getElementById("rest_fps");
                            var learn_update_rest = new EventSource("/rest_fps");
                            learn_update_rest.onmessage = function (e) { target_output_rest.innerHTML = e.data; };

                            var target_output_pure = document.getElementById("pure_fps");
                            var learn_update_pure = new EventSource("/pure_fps");
                            learn_update_pure.onmessage = function (e) { target_output_pure.innerHTML = e.data; };

                            var target_output_web_fps = document.getElementById("web_fps");
                            var learn_update_web_fps = new EventSource("/web_fps");
                            learn_update_web_fps.onmessage = function (e) { 
                                console.log("Received Web UI FPS:", e.data);
                                target_output_web_fps.innerHTML = e.data; };
                            var tableBody = document.getElementById('dynamicTable').getElementsByTagName('tbody')[0];
                            var final_stats_val = new EventSource("/final_detection");
                            final_stats_val.onmessage = function (e) {
                                
                                console.log("Received Data:", e.data);
                                let jsonData = e.data.replace(/'/g, '"');
                                let data;
                                try {
                                    data = JSON.parse(jsonData);
                                } catch (error) {
                                    console.error("Error parsing JSON:", error);
                                    return;
                                }                     
                                tableBody.innerHTML = '';
                                
                                let idCounter = 1;
                                for (const [key, value] of Object.entries(data)) {
                                    let newRow = tableBody.insertRow();
                                            
                                    let cell0 = newRow.insertCell(0);
                                    let cell1 = newRow.insertCell(1);
                                    let cell2 = newRow.insertCell(2);

                                    cell0.innerHTML = "#" + idCounter++;

                                    cell1.innerHTML = key;
                                    if (typeof value === 'number' && !Number.isInteger(value)) {
                                        cell2.innerHTML = value.toFixed(3);  
                                    } else {
                                        cell2.innerHTML = value;
                                    }
                                }
                            }
                
                            if (msg == "OBJECT DETECTION STATISTICS")
                            {
                            var final_count = new EventSource("/total_count");
                            final_count.onmessage = function (e) {
                                var close = document.getElementsByClassName("closebtn");
                                var i;
                                if (e.data > 10) {
                                    high();
                                } else if (e.data > 5) {
                                    medium();
                                } else if (e.data > 0) {
                                    low();
                                }

                                for (i = 0; i < close.length; i++) {
                                    close[i].onclick = function () {
                                        var div = this.parentElement;
                                        div.style.opacity = "0";
                                        setTimeout(function () { div.style.display = "none"; }, 600);
                                    }
                                }

                                function high() {
                                    var div = document.getElementById("high")
                                    div.style.display = "block";
                                    setTimeout(function () { div.style.opacity = "0"; }, 4500);
                                    setTimeout(function () { div.style.display = "none"; }, 5000);
                                    setTimeout(function () { div.style.opacity = "100"; }, 5000);
                                }
                                function medium() {
                                    var div = document.getElementById("medium")
                                    div.style.display = "block";
                                    setTimeout(function () { div.style.opacity = "0"; }, 4500);
                                    setTimeout(function () { div.style.display = "none"; }, 5000);
                                    setTimeout(function () { div.style.opacity = "100"; }, 5000);
                                }
                                function low() {
                                    var div = document.getElementById("low")
                                    div.style.display = "block";
                                    setTimeout(function () { div.style.opacity = "0"; }, 4500);
                                    setTimeout(function () { div.style.display = "none"; }, 5000);
                                    setTimeout(function () { div.style.opacity = "100"; }, 5000);
                                }
                            };
                        }
                            function updateData(endpoint, tableId) {
                                const eventSource = new EventSource(endpoint);
                                eventSource.onmessage = function(event) {
                                    const data = JSON.parse(event.data); 
                                    const table = document.getElementById(tableId);
                                
                                    table.innerHTML = "";
                                
                                    data.forEach(item => {
                                        const row = document.createElement("tr");
                                        const cell = document.createElement("td");
                                        cell.textContent = item;
                                        row.appendChild(cell);
                                        table.appendChild(row);
                                    });
                                };
                            }

                                let dynamicFeatureEnabled = false;
                                document.getElementById("toggleButton").addEventListener("click", function() {
                                dynamicFeatureEnabled = !dynamicFeatureEnabled;
                                if (dynamicFeatureEnabled) {
                                    enableDragDrop();
                                } else {
                                    disableDragDrop();
                                }
                                });


                    function enableDragDrop() {
                        const socket = io.connect('http://' + document.domain + ':' + location.port);
                        const sortableVideos = new Sortable(document.getElementById('sortable-list'), {
                            animation: 150,
                            group: 'shared',
                            onEnd: (event) => {
                                const items = Array.from(event.from.children).map(item => item.dataset.id);
                                socket.emit('update_order', { order: items });
                            }
                        });

                            const sortableTables = new Sortable(document.querySelector('.content'), {
                                animation: 150,
                                group: 'shared',
                                onEnd: (event) => {
                                    const items = Array.from(event.from.children).map(item => item.dataset.id);
                                    socket.emit('update_table_order', { order: items });
                                }
                            });

                            socket.on('update_order', (data) => {
                                sortableVideos.sort(data.order);
                            });

                            socket.on('update_table_order', (data) => {
                                sortableTables.sort(data.order);
                            });
                        }

                        function disableDragDrop() {
                                    Sortable.get(document.getElementById('sortable-list')).destroy();
                                    Sortable.get(document.querySelector('.content')).destroy();
                                }
                                    
                        var buttonClicked = false;
                                    
                        function toggleButton() {
                            var button = document.getElementById("toggleButton");
                            if (buttonClicked) {
                                button.style.backgroundColor = "lightgray"; 
                            } else {
                                button.style.backgroundColor = "lightblue"; 
                            }
                            buttonClicked = !buttonClicked;     
                    
                         }       
                        </script>
</body>

</html>

